docker-build:
  image: docker:20.10
  stage: build
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - |
      if [[ -z "$KUBECTL_VERSION" ]]; then
        tag=":$HELM_VERSION"
        echo "Helm version specified, using latest kubectl"
      else
        tag=":$HELM_VERSION-$KUBECTL_VERSION"
        echo "Forced kubectl version with Helm"
      fi
    - docker build --no-cache --pull -f Containerfile 
      --build-arg HELM_VERSION --build-arg KUBECTL_VERSION
      -t "$CI_REGISTRY_IMAGE${tag}" .
    - docker push "$CI_REGISTRY_IMAGE${tag}"
    - |
      if [[ "$TAG_LATEST" == "true" ]]; then
        docker tag "$CI_REGISTRY_IMAGE${tag}" "$CI_REGISTRY_IMAGE:latest"
        echo "Pushing also as latest tag"
        docker push "$CI_REGISTRY_IMAGE:latest"
      fi
  # Run this job only manually
  rules:
    - if: '$CI_PIPELINE_SOURCE == "web"'
      when: always
    - when: never
